diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
index 9132a584c..546de215a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
@@ -1,42 +1,107 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.IArmorWearing;
-import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.item.*;
+import net.minecraft.core.item.IArmorItem;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemQuiver;
+import net.minecraft.core.item.ItemQuiverEndless;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererBipedArmored<T extends Mob & IArmorWearing<HumanArmorShape>> extends MobRendererBiped<T> {
-    protected ModelBiped modelArmorA;
-    protected ModelBiped modelArmorB;
-
-    public MobRendererBipedArmored(ModelBiped model, float shadowSize) {
-        this(model, new ModelBiped(1.0F), new ModelBiped(0.5f), shadowSize);
+public abstract class MobRendererBipedArmored<T extends Mob & IArmorWearing<HumanArmorShape>> extends MobRendererBiped<T>{
+    public MobRendererBipedArmored(final float shadowSize) {
+        super(shadowSize);
     }
 
-    public MobRendererBipedArmored(ModelBiped model, ModelBiped modelArmorA, ModelBiped modelArmorB, float shadowSize) {
-        super(model, shadowSize);
+    @Override
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final T entity, final float brightness, final float partialTick, final int layer) {
+        if (layer == 0) return super.getAndSetupModelForLayer(entity, brightness, partialTick, layer);
+        final ItemStack itemstack = entity.getItemInArmorSlot(HumanArmorShape.values()[(entity.getNumArmorSlots() - 1) - (layer - 1)]);
+        if (itemstack == null) return null;
 
-        this.modelArmorA = modelArmorA;
-        this.modelArmorB = modelArmorB;
+        final Item item = itemstack.getItem();
+        if (item instanceof ItemQuiver) {
+            bindTexture("/assets/minecraft/textures/armor/quiver.png");
+        } else if (item instanceof ItemQuiverEndless) {
+            bindTexture("/assets/minecraft/textures/armor/quiver_golden.png");
+        } else if (item == Items.ARMOR_BOOTS_ICESKATES) {
+            bindTexture("/assets/minecraft/textures/armor/skates.png");
+        } else if (item instanceof IArmorItem) {
+            final IArmorItem armorItem = (IArmorItem) item;
+            if (armorItem.getArmorMaterial() == null) return null;
+            bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 3 ? 1 : 2)));
+        } else {
+            return null;
+        }
+        final StaticEntityModel model;
+        switch (layer) {
+            case 4:
+                model = getModel("armor.boots");
+                break;
+            case 3:
+                model = getModel("armor.leggings");
+                break;
+            case 2:
+                model = getModel("armor.chestplate");
+                break;
+            case 1:
+                model = getModel("armor.helmet");
+                break;
+            default:
+                return null;
+        }
+        return setupAnimations(entity, model, partialTick, layer);
     }
 
     @Override
-    protected void renderAdditional(T entity, float partialTick) {
+    protected @Nullable StaticEntityModel setupAnimations(@NotNull final T entity, @Nullable final StaticEntityModel model, final float partialTick, final int layer) {
+        final StaticEntityModel model1 = super.setupAnimations(entity, model, partialTick, layer);
+        switch (layer) {
+            case 4:
+                assert model != null;
+                model.getTransform("chest").visible = false;
+            case 3:
+                assert model != null;
+                model.getTransform("head").visible = false;
+                model.getTransform("rightArm").visible = false;
+                model.getTransform("leftArm").visible = false;
+                break;
+            case 2:
+                assert model != null;
+                model.getTransform("head").visible = false;
+                model.getTransform("rightLeg").visible = false;
+                model.getTransform("leftLeg").visible = false;
+                break;
+            case 1:
+                assert model != null;
+                model.getTransform("chest").visible = false;
+                model.getTransform("rightArm").visible = false;
+                model.getTransform("leftArm").visible = false;
+                model.getTransform("rightLeg").visible = false;
+                model.getTransform("leftLeg").visible = false;
+                break;
+        }
+        return model1;
+    }
+
+    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull T entity, final float partialTick) {
         final @Nullable ItemStack stack = entity.getItemInArmorSlot(HumanArmorShape.HEAD);
+
+        final StaticEntityModel model = getActiveModel(entity);
+
         if(stack != null) {
             GL11.glPushMatrix();
-            modelBipedMain.head.translateTo(0.0625F);
+            if (model != null) model.translateToBone("head");
             if (!(stack.getItem() instanceof IArmorItem)) {
                 GL11.glPushMatrix();
                 GL11.glEnable(GL11.GL_CULL_FACE);
@@ -49,87 +114,11 @@ public class MobRendererBipedArmored<T extends Mob & IArmorWearing<HumanArmorSha
             GL11.glPopMatrix();
         }
 
-        super.renderAdditional(entity, partialTick);
+        super.renderAdditional(tessellator, entity, partialTick);
     }
 
     @Override
-    public void render(Tessellator tessellator, T entity, double x, double y, double z, float yaw, float partialTick) {
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-
-        if (entity instanceof IItemHolding) {
-            ItemStack itemstack = ((IItemHolding) entity).getHeldItem();
-            if (((IItemHolding) entity).isLeftHanded()) {
-                this.modelArmorA.holdingLeftHand = this.modelArmorB.holdingLeftHand = this.modelBipedMain.holdingLeftHand |= itemstack != null;
-            } else {
-                this.modelArmorA.holdingRightHand = this.modelArmorB.holdingRightHand = this.modelBipedMain.holdingRightHand |= itemstack != null;
-            }
-        }
-        this.modelArmorA.sneaking = this.modelArmorB.sneaking = this.modelBipedMain.sneaking = entity.isSneaking();
-        this.modelArmorA.isRiding = this.modelArmorB.isRiding = this.modelBipedMain.isRiding = entity.isPassenger();
-
-        double realY = y - (double)entity.heightOffset;
-        if(entity.isSneaking() && !(entity instanceof PlayerLocal)) {
-            realY -= 0.125D;
-        }
-
-        super.render(tessellator, entity, x, realY, z, yaw, partialTick);
-
-        this.modelArmorA.holdingLarge = this.modelArmorB.holdingLarge = this.modelBipedMain.holdingLarge = false;
-        this.modelArmorA.sneaking = this.modelArmorB.sneaking = this.modelBipedMain.sneaking = false;
-        this.modelArmorA.holdingRightHand = this.modelArmorB.holdingRightHand = this.modelBipedMain.holdingRightHand = false;
-        this.modelArmorA.holdingLeftHand = this.modelArmorB.holdingLeftHand = this.modelBipedMain.holdingLeftHand = false;
-
-        GL11.glDisable(GL11.GL_BLEND);
-    }
-
-    @Override
-    protected boolean prepareArmor(T entity, int layer, float partialTick) {
-        ItemStack itemstack = entity.getItemInArmorSlot(HumanArmorShape.values()[(entity.getNumArmorSlots() - 1) - layer]);
-        if(itemstack != null)
-        {
-            Item item = itemstack.getItem();
-            if(item instanceof ItemQuiver)
-            {
-                bindTexture("/assets/minecraft/textures/armor/quiver.png");
-                ModelBiped modelBiped = modelArmorA;
-                modelBiped.body.visible = layer == 1 || layer == 2;
-                setArmorModel(modelBiped);
-                return true;
-            }
-            if(item instanceof ItemQuiverEndless)
-            {
-                bindTexture("/assets/minecraft/textures/armor/quiver_golden.png");
-                ModelBiped modelBiped = modelArmorA;
-                modelBiped.body.visible = layer == 1 || layer == 2;
-                setArmorModel(modelBiped);
-                return true;
-            }
-            if(item == Items.ARMOR_BOOTS_ICESKATES)
-            {
-                bindTexture("/assets/minecraft/textures/armor/skates.png");
-                ModelBiped modelBiped = modelArmorA;
-                modelBiped.legRight.visible = layer == 2 || layer == 3;
-                modelBiped.legLeft.visible = layer == 2 || layer == 3;
-                setArmorModel(modelBiped);
-                return true;
-            }
-            if(item instanceof IArmorItem && ((IArmorItem) item).getArmorMaterial() != null)
-            {
-                IArmorItem armorItem = (IArmorItem)item;
-                bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 2 ? 1 : 2)));
-                ModelBiped modelBiped = layer != 2 ? modelArmorA : modelArmorB;
-                modelBiped.head.visible = layer == 0;
-                modelBiped.hair.visible = layer == 0;
-                modelBiped.body.visible = layer == 1 || layer == 2;
-                modelBiped.armRight.visible = layer == 1;
-                modelBiped.armLeft.visible = layer == 1;
-                modelBiped.legRight.visible = layer == 2 || layer == 3;
-                modelBiped.legLeft.visible = layer == 2 || layer == 3;
-                setArmorModel(modelBiped);
-                return true;
-            }
-        }
-        return false;
+    protected int maxRenderLayer(@NotNull final T entity) {
+        return 4;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
index d782a3b58..491d6b2fa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
@@ -13,21 +14,21 @@ import java.util.Random;
 public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
     private static final Random sizeRandom = new Random();
     @Override
-    public void render(Tessellator tessellator, MobButterfly butterfly, double x, double y, double z, float yaw, float partialTick) {
+    public void render(@NotNull final Tessellator tessellator, @NotNull final MobButterfly butterfly, final double x, final double y, final double z, final float yaw, final float partialTick) {
         // 0.45 -> 0.8
         sizeRandom.setSeed((long) butterfly.getSkinVariant() << 16);
-        float scale = 0.45f + (sizeRandom.nextFloat() * 0.35f);
-        float yRot = MathHelper.lerp(butterfly.yRotO, butterfly.yRot, partialTick);
-        drawButterfly(tessellator, butterfly.tickCount, scale, yRot, x, y, z, partialTick, renderDispatcher.textureManager, getTexture(butterfly));
+        final float scale = 0.45f + (sizeRandom.nextFloat() * 0.35f);
+        final float yRot = MathHelper.lerp(butterfly.yRotO, butterfly.yRot, partialTick);
+        drawButterfly(tessellator, butterfly.tickCount, scale, yRot, x, y, z, partialTick, this.renderDispatcher.textureManager, getTexture(butterfly));
     }
 
     @Override
-    public void renderPreview(Tessellator tessellator, MobButterfly butterfly, double x, double y, double z, float yaw, float partialTick) {
-        float yRot = MathHelper.lerp(butterfly.yRotO, butterfly.yRot, partialTick);
-        drawButterfly(tessellator, butterfly.tickCount, 1.25f, -yRot, x, y + 0.5, z, partialTick, renderDispatcher.textureManager, getTexture(butterfly));
+    public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final MobButterfly butterfly, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        final float yRot = MathHelper.lerp(butterfly.yRotO, butterfly.yRot, partialTick);
+        drawButterfly(tessellator, butterfly.tickCount, 1.25f, -yRot, x, y + 0.5, z, partialTick, this.renderDispatcher.textureManager, getTexture(butterfly));
     }
 
-    public static void drawButterfly(Tessellator tessellator, int ticksAlive, float scale, float yRot, double x, double y, double z, float partialTick, TextureManager textureManager, String texture) {
+    public static void drawButterfly(final Tessellator tessellator, final int ticksAlive, final float scale, final float yRot, final double x, final double y, final double z, final float partialTick, final TextureManager textureManager, final String texture) {
         textureManager.bindTexture(textureManager.loadTexture(texture));
         GL11.glPushMatrix();
         GL11.glTranslatef((float) x, (float) y + 0.25f, (float) z);
@@ -40,10 +41,10 @@ public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
 
         GL11.glRotatef(-22.5f, 1, 0, 0);
 
-        float xOff = -0.5F;
-        float zOff = -0.5F;
+        final float xOff = -0.5F;
+        final float zOff = -0.5F;
 
-        float flapAngle = (MathHelper.sin(ticksAlive + partialTick) + 1) * 22.5f + 5;
+        final float flapAngle = (MathHelper.sin(ticksAlive + partialTick) + 1) * 22.5f + 5;
 
         GL11.glPushMatrix();
         GL11.glRotatef(-flapAngle, 0, 0, 1);
@@ -71,7 +72,7 @@ public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
         GL11.glPopMatrix();
     }
 
-    public String getTexture(MobButterfly butterfly) {
+    public static String getTexture(final MobButterfly butterfly) {
         if (!Minecraft.getMinecraft().gameSettings.mobVariants.value) {
             return butterfly.getDefaultEntityTexture();
         } else {
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
index 76e39da41..329e8e135 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
@@ -1,19 +1,44 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.core.entity.animal.MobChicken;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 public class MobRendererChicken extends MobRenderer<MobChicken> {
-    public MobRendererChicken(ModelBase modelbase, float f)
-    {
-        super(modelbase, f);
+
+    public MobRendererChicken(final float shadowSize) {
+        super(shadowSize);
     }
+
     @Override
-    protected float limbSway(MobChicken entity, float partialTick) {
-        float flap = entity.oFlap + (entity.flap - entity.oFlap) * partialTick;
-        float flapSpeed = entity.oFlapSpeed + (entity.flapSpeed - entity.oFlapSpeed) * partialTick;
-        return (MathHelper.sin(flap) + 1.0F) * flapSpeed;
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobChicken entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model = getModel("main");
+        model.resetBones();
+
+        final float limbSwing = getLimbSwing(entity, partialTick);
+        final float limbYaw = getLimbYaw(entity, partialTick);
+        final float limbPitch = getLimbPitch(entity, partialTick);
+
+        final BoneTransform leg0 = model.getTransform("leg0");
+        final BoneTransform leg1 = model.getTransform("leg1");
+        final BoneTransform wing0 = model.getTransform("wing0");
+        final BoneTransform wing1 = model.getTransform("wing1");
+
+        leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        wing0.rotZ = limbPitch;
+        wing1.rotZ = -limbPitch;
+
+        return model;
     }
 
+    @Override
+    protected float getLimbPitch(@NotNull final MobChicken entity, final float partialTick) {
+        final float flap = MathHelper.lerp(entity.oFlap, entity.flap, partialTick);
+        final float flapSpeed = MathHelper.lerp(entity.oFlapSpeed, entity.flapSpeed, partialTick);
+        return (MathHelper.sin(flap) + 1.0F) * flapSpeed;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
index 184944a4d..b0c75003f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
@@ -1,89 +1,92 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.model.ModelCreeper;
 import net.minecraft.core.entity.monster.MobCreeper;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererCreeper extends MobRenderer<MobCreeper>
-{
-    public MobRendererCreeper()
-    {
-        super(new ModelCreeper(), 0.5F);
-        chargedModel = new ModelCreeper(2.0F);
+public class MobRendererCreeper extends MobRenderer<MobCreeper> {
+
+    public MobRendererCreeper(final float shadowSize) {
+        super(shadowSize);
+    }
+
+    @Override
+    protected int getOverlayColor(final @NotNull MobCreeper creeper, final float brightness, final float partialTick) {
+        final float step = creeper.getSwelling(partialTick);
+        if ((int)(step * 10.0f) % 2 == 0) { return 0; }
+        return Color.intToIntARGB(MathHelper.clamp((int)(step * 0.2f * 255.0f), 0, 255), 255, 255,255);
     }
 
     @Override
-    protected void setupScale(MobCreeper creeper, float partialTick) {
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobCreeper creeper, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model;
+        if (layer == 1) { // Setup funky powered rendering
+            model = getModel("charged");
+            bindTexture("/assets/minecraft/textures/armor/power.png");
+            final float ticks = creeper.tickCount + partialTick;
+            GL11.glMatrixMode(GL11.GL_TEXTURE);
+            GL11.glLoadIdentity();
+            final float _x = ticks * 0.01F;
+            final float _y = ticks * 0.01F;
+            GL11.glTranslatef(_x, _y, 0.0F);
+            GL11.glMatrixMode(GL11.GL_MODELVIEW);
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glColor4f(0.5f, 0.5f, 0.5f, 1.0F);
+            GL11.glDisable(GL11.GL_LIGHTING);
+            GL11.glBlendFunc(GL11.GL_ONE, GL11.GL_ONE);
+        } else if (layer == 2) { // Reset funky powered rendering
+            GL11.glMatrixMode(GL11.GL_TEXTURE);
+            GL11.glLoadIdentity();
+            GL11.glMatrixMode(GL11.GL_MODELVIEW);
+            GL11.glEnable(GL11.GL_LIGHTING);
+            GL11.glDisable(GL11.GL_BLEND);
+            return null;
+        } else {
+            model = getModel("main");
+        }
+        model.resetBones();
+
+        final float bodyYaw = getBodyYaw(creeper, partialTick);
+        final float headYaw = getHeadYaw(creeper, partialTick) - bodyYaw;
+        final float headPitch = getHeadPitch(creeper, partialTick);
+        final float limbSwing = getLimbSwing(creeper, partialTick);
+        final float limbYaw = getLimbYaw(creeper, partialTick);
+
+        final BoneTransform body = model.getTransform("body");
+        final BoneTransform head = model.getTransform("head");
+        head.rotY = headYaw;
+        head.rotX = headPitch;
+
+        final BoneTransform leg0 = model.getTransform("leg0");
+        final BoneTransform leg1 = model.getTransform("leg1");
+        final BoneTransform leg2 = model.getTransform("leg2");
+        final BoneTransform leg3 = model.getTransform("leg3");
+
+        leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg2.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg3.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+
         float g = creeper.getSwelling(partialTick);
         final float wobble = 1.0f + MathHelper.sin(g * 100.0f) * g * 0.01f;
-        if (g < 0.0f) {
-            g = 0.0f;
-        }
-        if (g > 1.0f) {
-            g = 1.0f;
-        }
+        g = MathHelper.clamp(g, 0, 1);
         g *= g;
         g *= g;
         final float s = (1.0f + g * 0.4f) * wobble;
         final float hs = (1.0f + g * 0.1f) / wobble;
-        GL11.glScalef(s, hs, s);
+        body.scaleX = s;
+        body.scaleY = hs;
+        body.scaleZ = s;
+        return model;
     }
 
     @Override
-    protected int getOverlayColor(MobCreeper creeper, float brightness, float partialTick) {
-        final float step = creeper.getSwelling(partialTick);
-        if ((int)(step * 10.0f) % 2 == 0) {
-            return 0;
-        }
-        int _a = (int)(step * 0.2f * 255.0f);
-        if (_a < 0) {
-            _a = 0;
-        }
-        if (_a > 255) {
-            _a = 255;
-        }
-        final int r = 255;
-        final int g = 255;
-        final int b = 255;
-        return _a << 24 | r << 16 | g << 8 | b;
+    protected int maxRenderLayer(@NotNull final MobCreeper entity) {
+        return entity.getPowered() ? 2 : 0;
     }
-
-    @Override
-    protected boolean prepareArmor(MobCreeper entity, int layer, float partialTick) {
-        if(entity.getPowered())
-        {
-            if(layer == 1)
-            {
-                float f1 = (float)entity.tickCount + partialTick;
-                bindTexture("/armor/power.png");
-                GL11.glMatrixMode(GL11.GL_TEXTURE);
-                GL11.glLoadIdentity();
-                float f2 = f1 * 0.01F;
-                float f3 = f1 * 0.01F;
-                GL11.glTranslatef(f2, f3, 0.0F);
-                setArmorModel(chargedModel);
-                GL11.glMatrixMode(GL11.GL_MODELVIEW);
-                GL11.glEnable(GL11.GL_BLEND);
-                float brightness = 0.5F;
-                GL11.glColor4f(brightness, brightness, brightness, 1.0F);
-                GL11.glDisable(GL11.GL_LIGHTING);
-                GL11.glBlendFunc(1, 1);
-                return true;
-            }
-            if(layer == 2)
-            {
-                GL11.glMatrixMode(GL11.GL_TEXTURE);
-                GL11.glLoadIdentity();
-                GL11.glMatrixMode(GL11.GL_MODELVIEW);
-                GL11.glEnable(GL11.GL_LIGHTING);
-                GL11.glDisable(GL11.GL_BLEND);
-            }
-        }
-        return false;
-    }
-
-
-    private ModelBase chargedModel;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
index 45cb7a74f..6ce9f0fab 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererFireflyCluster.java
@@ -1,11 +1,12 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.client.entity.particle.ParticleFirefly;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
@@ -14,32 +15,30 @@ import java.util.Random;
 
 public class MobRendererFireflyCluster extends EntityRenderer<MobFireflyCluster> {
 	private final List<ParticleFirefly> fireflies = new ArrayList<>();
-	private final Minecraft mc;
-	private final Random rand = new Random(0);
+    private final Random rand = new Random(0);
 	private long lastTick;
 
 	public MobRendererFireflyCluster() {
 		for (int i = 0; i < 20; i++) {
-			ParticleFirefly fx = new ParticleFirefly(null, rand.nextFloat() - 0.5f, rand.nextFloat() - 0.5f, 0, 0, 0, 0, 0);
+			final ParticleFirefly fx = new ParticleFirefly(WorldClient.EMPTY_WORLD, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, 0);
 			fx.noPhysics = true;
-			fx.setAge(rand.nextInt(20));
-			fireflies.add(fx);
+			fx.setAge(this.rand.nextInt(20));
+            this.fireflies.add(fx);
 		}
-		mc = Minecraft.getMinecraft();
-		lastTick = System.currentTimeMillis();
+        this.lastTick = System.currentTimeMillis();
 	}
 
 	@Override
-	public void render(Tessellator tessellator, MobFireflyCluster parent, double x, double y, double z, float yaw, float partialTick) {
+	public void render(@NotNull final Tessellator tessellator, @NotNull final MobFireflyCluster parent, final double x, final double y, final double z, final float yaw, final float partialTick) {
 		// Fireflies are rendered as particles which are spawned in the entity class
 	}
 
 	@Override
-	public void renderPreview(Tessellator tessellator, MobFireflyCluster entity, double x, double y, double z, float yaw, float partialTick) {
+	public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final MobFireflyCluster entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
 		super.renderPreview(tessellator, entity, x, y, z, yaw, partialTick);
 
-		long currentTick = System.currentTimeMillis();
-		int storedTicks = (int) ((currentTick - lastTick) / 50.0f);
+		final long currentTick = System.currentTimeMillis();
+		final int storedTicks = (int) ((currentTick - this.lastTick) / 50.0f);
 
 		GL11.glPushMatrix();
 		GL11.glTranslatef(0, 0.75f, 0);
@@ -47,17 +46,17 @@ public class MobRendererFireflyCluster extends EntityRenderer<MobFireflyCluster>
 		GL11.glEnable(GL11.GL_BLEND);
 		Lighting.disable();
 		TextureRegistry.particleAtlas.bind();
-		Tessellator t = Tessellator.instance;
+		final Tessellator t = Tessellator.instance;
 		t.startDrawingQuads();
-		for (int i = 0; i < fireflies.size(); i++) {
-			ParticleFirefly firefly = fireflies.get(i);
+		for (int i = 0; i < this.fireflies.size(); i++) {
+			final ParticleFirefly firefly = this.fireflies.get(i);
 			firefly.renderParticleInGui(t, partialTick);
 			for (int j = 0; j < storedTicks; j++) {
 				firefly.tickGui();
-				lastTick = currentTick;
+                this.lastTick = currentTick;
 			}
 			if (firefly.removed) {
-				fireflies.remove(i);
+                this.fireflies.remove(i);
 				i--;
 			}
 		}
@@ -65,13 +64,13 @@ public class MobRendererFireflyCluster extends EntityRenderer<MobFireflyCluster>
 		GL11.glEnable(GL11.GL_CULL_FACE);
 		GL11.glPopMatrix();
 
-		if (fireflies.size() < 20) {
-			for (int i = fireflies.size(); i < 20; i++) {
-				if (rand.nextInt(4) == 0) continue;
-				ParticleFirefly fx = new ParticleFirefly(null, rand.nextFloat() - 0.5f, rand.nextFloat() - 0.5f, 0, 0, 0, 0, entity.getColor().getId());
+		if (this.fireflies.size() < 20) {
+			for (int i = this.fireflies.size(); i < 20; i++) {
+				if (this.rand.nextInt(4) == 0) continue;
+				final ParticleFirefly fx = new ParticleFirefly(WorldClient.EMPTY_WORLD, this.rand.nextFloat() - 0.5f, this.rand.nextFloat() - 0.5f, 0, 0, 0, 0, entity.getColor().getId());
 				fx.noPhysics = true;
-				fx.setAge(rand.nextInt(20));
-				fireflies.add(fx);
+				fx.setAge(this.rand.nextInt(20));
+                this.fireflies.add(fx);
 			}
 		}
 	}
